/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.apidesign.apifest08.test;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import junit.framework.TestCase;
import org.apidesign.apifest08.currency.ConversionResult;
import org.apidesign.apifest08.currency.Convertor;
import org.apidesign.apifest08.currency.ConvertorCurrency;
import org.apidesign.apifest08.currency.ExchangeRateProvider;

/**
 *
 * @author arnostvalicek
 */
public class RemainderTest extends TestCase {
    private static ConvertorCurrency CZK = ConvertorCurrency.getInstance("CZK");
    private static ConvertorCurrency SKK = ConvertorCurrency.getInstance("SKK");
    private static ConvertorCurrency USD = ConvertorCurrency.getInstance("USD");
    private SimpleDateFormat df;
    
    @Override
    protected void setUp() throws Exception {
        super.setUp();
        df = new SimpleDateFormat("yyyy-MM-dd HH:mm zzzz");
        
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();
    }
    
    public void testRemainder1() {
        Convertor c = Task2Test.createUsdToSkkConvertor();
        {
            final BigDecimal convertedValue = new BigDecimal("12.34");
            ConversionResult result = c.convertWithReversibleRates(SKK,USD,convertedValue);
            //System.out.println("Result = "+result);
            assertEquals("Converted", new BigDecimal("0.61"),result.getConverted());
            assertEquals("Remainder", new BigDecimal("0.14"),result.getRemainder());
            
            ConversionResult resultBack = c.convertWithReversibleRates(USD, SKK, result.getConverted());
            assertEquals("Conversion back", convertedValue, resultBack.getConverted().add(result.getRemainder()));
            
        }
        {
            ConversionResult result = c.convertWithReversibleRates(SKK,USD,new BigDecimal("20.00"));
            //System.out.println("Result = "+result);
        }
    
        {
            ConversionResult result = c.convertWithReversibleRates(USD,SKK,new BigDecimal("1.00"));
            //System.out.println("Result = "+result);
        }
        
    }
    
    public void testRemainderStripCents() {
        ConvertorCurrency CZK_cents=ConvertorCurrency.getInstance("CZK", 2);
        ConvertorCurrency CZK_nocents=ConvertorCurrency.getInstance("CZK", 0);
        
        
        ExchangeRateProvider exchangeRateProvider = ExchangeRateProvider.createExchangeRateProvider();
        exchangeRateProvider.addFixedCurencyRate(CZK_cents, new BigDecimal(1), CZK_nocents, new BigDecimal(1));
        
        Convertor c = Convertor.createConvertor(exchangeRateProvider);
        
        ConversionResult result = c.convertWithReversibleRates(CZK_cents, CZK_nocents, new BigDecimal("2.34"));
        assertEquals("Converted",new BigDecimal("2"),result.getConverted());
        assertEquals("Remainder",new BigDecimal("0.34"),result.getRemainder());
    }
    
    

}
